/* Copyright (C) NHR@FAU, University Erlangen-Nuremberg.
 * All rights reserved.
 * Use of this source code is governed by a MIT-style
 * license that can be found in the LICENSE file.*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "comm.h"
#include "matrix.h"
#include "progress.h"
#include "solver.h"
#include "timing.h"

int main(int argc, char** argv)
{
    int rank;
    double timeStart, timeStop;
    Matrix m;
    Solver s;

    // commInit(s.comm, argc, argv);

    // FILE* fp;
    // if (commIsMaster(s.comm)) fp = initResidualWriter();

    if (argc != 2) {
        printf("Usage: %s <configFile>\n", argv[0]);
        exit(EXIT_SUCCESS);
    }

    matrixRead(&m, argv[1]);
    matrixDump(&m);
    exit(EXIT_SUCCESS);

    double te  = 1000;
    double t   = 0.0;
    double res = 0.0;

    timeStart = getTimeStamp();
    while (t <= te) {

        // if (commIsMaster(s.comm)) writeResidual(fp, t, res);

        t += 0.5;

#ifdef VERBOSE
        if (commIsMaster(s.comm)) {
            printf("TIME %f , TIMESTEP %f\n", t, d.dt);
        }
#else
        printProgress(t);
#endif
    }
    timeStop = getTimeStamp();
    if (commIsMaster(s.comm)) {
        printf("Solution took %.2fs\n", timeStop - timeStart);
    }
    // if (commIsMaster(s.comm)) fclose(fp);
    commFinalize(s.comm);
    return EXIT_SUCCESS;
}
